'+--------------------------------------------------------------------------+
'|                               SplashAni                                  |
'|                                                                          |
'|                Example of 32-bit layered splash screen                   |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 09-26-2008 (MM-DD-YYYY)            |
'|                        Last revised : 09-26-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "SplashAni.exe"

#INCLUDE "Layered.inc"
#INCLUDE "Gdimage.inc"

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------
%FRAME_SizeX = 420 '// Must match the animation frame width
%FRAME_SizeY = 331 '// Must match the animation frame height
%FRAME_Count = 1   '// The frame number
%USE_StepX   = 0   '// X step value in pixel
%USE_StepY   = 0   '// Y step value in pixel

GLOBAL ImageArray() AS LONG

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEXA
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS DWORD
'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZLAYERED"
'
   ' hMutex = CreateMutex(BYVAL %Null, 0, zClass)
   ' IF hMutex THEN
   '    IF GetLastError = %ERROR_ALREADY_EXISTS THEN
   '       DO
   '          hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
   '          WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
   '       LOOP
   '       IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
   '       CALL SetForeGroundWindow(hFound)
   '       FUNCTION = 0
   '       EXIT FUNCTION
   '    END IF
   ' END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = GetModuleHandle("")
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED OR %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "Splash"
       hMain = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN
          DIM ImageArray(1 TO 5)
          CALL SetImage(hMain)
          CALL ShowWindow(hMain, %SW_SHOW)

          '//IF %FRAME_Count > 1 THEN 
          CALL SetTimer(hMain, 1, 50, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          '//IF %FRAME_Count > 1 THEN 
          CALL KillTimer(hMain, 1)

          '//FreeUp resources
          FOR x = LBOUND(ImageArray) TO UBOUND(ImageArray)
              IF ImageArray(x) THEN GdipDisposeImage(ImageArray(x)): ImageArray(x) = 0
          NEXT

          FUNCTION = msg.wParam
       END IF

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg

    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF
         
    CASE %WM_TIMER
         CALL SetImage(hWnd)
         
    CASE %WM_NCHITTEST
         FUNCTION = %HTCAPTION: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GetImageSize (BYVAL Img AS LONG, imgW AS LONG, imgH AS LONG) EXPORT
    CALL GdipGetImageWidth(Img, imgW)
    CALL GdipGetImageHeight(Img, imgH)
END SUB

SUB SetImage(BYVAL hWnd AS LONG)
    LOCAL graphics, DesktopDC, hMemDC, hBmp, Img, imgW, imgH, ImgAttr, x, y, One AS LONG
    LOCAL rw AS RECT, bmp AS BITMAP, bi AS BITMAPINFO
    LOCAL dwp AS DWORD PTR
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL
    LOCAL sCoef AS SINGLE
    
    STATIC Alpha2, StepAlpha2, xMove3, FlipMove3, nHue, FlipHue, AngleDegree AS LONG    
   
    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

    DesktopDC = GetDC(0)
    
    '// Draw active frame to new memory DC
    hMemDC = CreateCompatibleDC(DesktopDC)
    hBmp = CreateCompatibleBitmap(DesktopDC, lpSize.Cx, lpSize.CY)
	 CALL SelectObject(hMemDC, hBmp)
    IF GdipCreateFromHDC(hMemDC, graphics) = 0 THEN
       CALL GdipSetInterpolationMode(graphics, 2)

       '// Draw layer 1 with respect of the z-order
       IF ImageArray(1) = 0 THEN ImageArray(1) = zLoadImageFromFile((EXE.Path$ + "Flare204x204.png"), imgW, imgH, 0)
       Img = ImageArray(1)
       IF Img THEN
          CALL GetImageSize(Img, imgW, imgH)
          INCR AngleDegree: IF AngleDegree > 360 THEN AngleDegree = 0
          CALL ZI_RotateImage(hMemDC, Img, 63, 63, AngleDegree, 128)
       END IF

       '// Draw layer 2 with respect of the z-order
       IF ImageArray(2) = 0 THEN ImageArray(2) = zLoadImageFromFile((EXE.Path$ + "LensCrown.png"), imgW, imgH, 0)
       Img = ImageArray(2)
       IF Img THEN
          CALL GetImageSize(Img, imgW, imgH)
          CALL GdipDrawImageRectRectI(graphics, Img, x, y, imgW, imgH, 0, 0, imgW, imgH, 2, ImgAttr)
       END IF

       '// Draw layer 3 with respect of the z-order
       IF ImageArray(3) = 0 THEN ImageArray(3) = zLoadImageFromFile((EXE.Path$ + "LensOptical.png"), imgW, imgH, 0)
       Img = ImageArray(3)
       IF Img THEN
          CALL GetImageSize(Img, imgW, imgH)
          IF Alpha2 = 0 THEN Alpha2 = 256
          IF Alpha2 < 20 THEN
             StepAlpha2 = 5
          ELSEIF Alpha2 > 255 THEN 
             StepAlpha2 = -5
          END IF
          Alpha2 = Alpha2 + StepAlpha2

          ImgAttr = ZI_SetImageAlpha(Alpha2)
          CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, imgW, imgH, 0, 0, imgW, imgH, 2, ImgAttr)
          imgAttr = 0
       END IF

       '// Draw layer 4 with respect of the z-order
       IF ImageArray(4) = 0 THEN ImageArray(4) = zLoadImageFromFile((EXE.Path$ + "LensFlare.png"), imgW, imgH, 0)
       Img = ImageArray(4)
       IF Img THEN
          CALL GetImageSize(Img, imgW, imgH)
          IF FlipMove3 = 0 THEN
             xMove3 = xMove3 + 2
             IF xMove3 > 260 THEN FlipMove3 = -1
          ELSE
             xMove3 = xMove3 - 2
             IF xMove3 < 0 THEN FlipMove3 = 0
          END IF
          CALL GdipDrawImageRectRectI(graphics, Img, 103 + xMove3, 100 + (xMove3 \ 2), imgW - (xMove3\4), imgH - (xMove3\4), 0, 0, imgW, imgH, 2, ImgAttr)
          '//CALL GdipDisposeImage(Img)
       END IF

       '// Draw layer 5 with respect of the z-order
       IF ImageArray(5) = 0 THEN ImageArray(5) = zLoadImageFromFile((EXE.Path$ + "LensLogo.png"), imgW, imgH, 0)
       Img = ImageArray(5)
       IF Img THEN
          CALL GetImageSize(Img, imgW, imgH)
          
          IF FlipHue = 0 THEN
             nHue = nHue + 4
             IF nHue > 250 THEN FlipHue = -1
          ELSE
             nHue = nHue - 4
             IF nHue < 10 THEN FlipHue = 0
          END IF
          ImgAttr = ZI_SetImageAttributesHue(nHue)
          sCoef = (773 + nHue) / 1000

          CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, imgW * sCoef, imgH * sCoef, 0, 0, imgW, imgH, 2, ImgAttr)
          ImgAttr = 0
       END IF

       CALL GdipDeleteGraphics(graphics)
    END IF
    
    CALL GetObject(hBmp, sizeof(bmp), bmp)
    
    bf.BlendOp             = %AC_SRC_OVER
    bf.BlendFlags          = 0
    bf.AlphaFormat         = %AC_SRC_ALPHA '// Use source alpha
    bf.SourceConstantAlpha = 255 '//alpha
    
    CALL UpdateLayeredWindow (hWnd, DesktopDC, lp, lpSize, hMemDC, ptSrc, 0, bf, %ULW_ALPHA)
    
    CALL DeleteObject(hBmp)
    CALL DeleteDC(hMemDC)
    CALL ReleaseDC(0, DesktopDC)
END SUB
